/*
 * Copyright 2010 Trustees of the University of Pennsylvania Licensed under the
 * Educational Community License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 * http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
package metridoc

import metridoc.dsl.JobManager
import metridoc.dsl.JobBuilder

/**
 * Created by IntelliJ IDEA.
 * User: tbarker
 * Date: 5/3/11
 * Time: 3:02 PM
 * To change this template use File | Settings | File Templates.
 */
class Main {
    public static void main(String[] args) {
        new Main().run(args)
    }

    def void run(args) {
        if(args) {
            if(args.size() != 1) {
                usage()
            }
            def classLoader = Thread.currentThread().contextClassLoader
            def jobClass = classLoader.loadClass(args[0])
            def job = classLoader.loadClass(args[0]).newInstance()
            job.metaClass.jobs  = {Closure closure ->
                new JobBuilder().load(jobClass).run("defaultJob")
            }
            job.run()
        } else {
            usage()
        }
    }

    def static usage() {
        println "metridoc must have only one argument indicating what job to run, ie metridoc.RunJob"
        System.exit(-1)
    }

}
