/*
 * Copyright 2010 Trustees of the University of Pennsylvania Licensed under the
 * Educational Community License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 * http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
package metridoc.dsl

/**
 * Created by IntelliJ IDEA.
 * User: tbarker
 * Date: 5/16/11
 * Time: 1:34 PM
 * To change this template use File | Settings | File Templates.
 */
class IllegalOverrideException extends RuntimeException {

    IllegalOverrideException(String s) {
        super(s)
    }

    def static IllegalOverrideException byServiceName(String name, currentService, overrideService) {
        throw new IllegalOverrideException(
            "${getPrefix(name, currentService, overrideService)} overrides are " +
                    "not allowed for this service"
        )
    }

    def static IllegalOverrideException byType(String name, currentService, overrideService) {
        throw new IllegalOverrideException(
            "${getPrefix(name, currentService, overrideService)} any overrides " +
                    "for this service must be of the same type (tried to override from ${currentService.class.name} " +
                    "to ${overrideService})"

        )
    }

    private static String getPrefix(String serviceName, currentService, overrideService) {
        return "Could not override service ${serviceName} from ${currentService} to ${overrideService} since"
    }
}
