/*
 * Copyright 2010 Trustees of the University of Pennsylvania Licensed under the
 * Educational Community License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 * http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
package metridoc.dsl

import metridoc.utils.Assert

/**
 * Created by IntelliJ IDEA.
 * User: tbarker
 * Date: 6/27/11
 * Time: 3:01 PM
 */
class RestrictedSet implements Set {

    def Set contents = new HashSet()


    int size() {
        return contents.size()
    }

    boolean isEmpty() {
        return contents.isEmpty()
    }

    boolean contains(Object o) {
        return contents.contains(o)
    }

    Iterator iterator() {
        return contents.iterator()
    }

    Object[] toArray() {
        return contents.toArray()
    }

    def Object[] toArray(Object[] ts) {
        return contents.toArray(ts)
    }

    boolean add(Object e) {
        Assert.isTrue(!contents.contains(e), "You can only add ${e} once, or it needs to be removed before adding again")
        return contents.add(e)
    }

    boolean remove(Object o) {
        return remove(o)
    }

    boolean containsAll(Collection objects) {
        return contents.containsAll(objects)
    }

    boolean addAll(Collection es) {
        return contents.addAll(es)
    }

    boolean retainAll(Collection objects) {
        return contents.retainAll(objects)
    }

    boolean removeAll(Collection objects) {
        return contents.removeAll(objects)
    }

    void clear() {
        contents.clear()
    }
}
